//
//  javasource.cpp
//  Lily
//
//  Created by KMY on 2015/05/09.
//  Copyright (c) 2015年 KMY. All rights reserved.
//

#include "javasource.h"
#include "message.h"

JavaSource::JavaSource() : File() {
	packageName = 0;
	className = 0;
}

JavaSource::JavaSource(const char *cn, const char *pgn) {
	Character::strcpyn(cn, &className);
	Character::strcpyn(pgn, &packageName);
	setPackageName(pgn);
}

JavaSource::~JavaSource() {
	delete packageName;
	delete className;
}

void JavaSource::setPackageName(const char *pkn) {
	Character::strcpyn(pkn, &packageName);
	reloadFileName();
}

void JavaSource::reloadFileName() {

	// パッケージの . を / に置き換え
	char* pkgName;
	Character::strcpyn(packageName, &pkgName);
	char* c = pkgName;
	while (*c) {
		if (*c == '.') *c = '/';
		c++;
	}
	
	char fn[512];
	sprintf(fn, "%s/%s.java", pkgName, className);
	File::setFileName(fn);
	
	delete pkgName;
}

void JavaSource::startJava() {
	if (!open("wb+")) {
		char errmes[512];
		char *fn;
		getFileName(&fn);
		sprintf(errmes, "ファイル %s が開けません", fn);
		Message::error(errmes, Message::MES_CORE_ERROR);
		delete fn;
		return;
	}
	char str[512];
	sprintf(str, "// Java from Lily\n"
			"package %s;\n"
			"public class %s {\n", packageName, className);
	write(str);
}

void JavaSource::startJavaMain() {
	startJava();
	write("public static void main(String[] args) {\n");
}

void JavaSource::endJava() {
	write("}\n");
	close();
}

void JavaSource::endJavaMain() {
	write("}\n");
	endJava();
}
